#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <EditConstants.au3>
#include <GuiEdit.au3>
#Include <WinAPIEx.au3>
#Include <APIConstants.au3>
#Include <Date.au3>
;
; by Joakim Schicht 26.07.11
;
;Global Const $tagPARTITION_INFO = 'int64 StartingOffset;int64 PartitionLength;dword HiddenSectors;dword PartitionNumber;byte PartitionType;boolean BootIndicator;boolean RecognizedPartition;boolean RewritePartition;'
Global $List[30], $Drive = DriveGetDrive('All')
Global $tSTORAGE_DEVICE_NUMBER, $Volume, $hFile
$Form = GUICreate("LockVolume - by Joakim Schicht", 520, 250, -1, -1)
$Combo1 = GUICtrlCreateCombo("", 20, 20, 400, 25)
$ButtonRefresh = GUICtrlCreateButton("Refresh", 440, 20, 60, 20)
$Label1 = GUICtrlCreateLabel("", 20, 50, 200, 17)
$ButtonLock = GUICtrlCreateButton("Lock It", 20, 60, 80, 40)
$ButtonDismount = GUICtrlCreateButton("Safe Dismount", 120, 70, 80, 20)
$ButtonUnlock = GUICtrlCreateButton("Unlock It", 220, 60, 80, 40)
$ButtonForceDismount = GUICtrlCreateButton("Force Dismount", 410, 60, 90, 20)
$ButtonRemount = GUICtrlCreateButton("Force Remount", 410, 90, 90, 20)
$myctredit = GUICtrlCreateEdit("A LockDismount (by TheK) imitation in AutoIt." & @CRLF, 0, 125, 520, 125, $ES_AUTOVSCROLL + $WS_VSCROLL)
_GUICtrlEdit_SetLimitText($myctredit, 128000)
_DisplayInfo("" & @CRLF)
_DisplayInfo("Started: " & _Now() & @CRLF)
_DisplayInfo("" & @CRLF)
_GetPhysicalDrives()
_GetVolumes()

GUISetState(@SW_SHOW)

While 1
$nMsg = GUIGetMsg()

Select

	Case $nMsg = $ButtonRefresh
		_GetPhysicalDrives()
		_GetVolumes()
		
	Case $nMsg = $ButtonLock
		_Lock()
		
	Case $nMsg = $ButtonUnlock
		_Unlock()
		
	Case $nMsg = $ButtonDismount
		_Dismount()
		
	Case $nMsg = $ButtonForceDismount
		_DismountForce()
		
	Case $nMsg = $ButtonRemount
		_ForceRemount()
		
	Case $nMsg = $GUI_EVENT_CLOSE
		Exit

EndSelect
WEnd

Func _Lock()
$TargetDrive = StringMid(GUICtrlRead($Combo1),1,2)
$lock = _WinAPI_LockVolume($TargetDrive)
If $lock = 0 Then
	_DisplayInfo("Error when locking " & $TargetDrive & @CRLF)
	Return
EndIf
_DisplayInfo("Successfully locked " & $TargetDrive & @CRLF)
GUICtrlSetState($ButtonLock, $GUI_DISABLE)
GUICtrlSetState($Combo1, $GUI_DISABLE)
GUICtrlSetState($ButtonRefresh, $GUI_DISABLE)
EndFunc

Func _Unlock()
$TargetDrive = StringMid(GUICtrlRead($Combo1),1,2)
$unlock = _WinAPI_UnLockVolume($hFile)
If $unlock = 0 Then
	_DisplayInfo("Error when unlocking " & $TargetDrive & @CRLF)
	Return
EndIf
_DisplayInfo("Successfully unlocked " & $TargetDrive & @CRLF)
GUICtrlSetState($ButtonLock, $GUI_ENABLE)
GUICtrlSetState($Combo1, $GUI_ENABLE)
GUICtrlSetState($ButtonRefresh, $GUI_ENABLE)
_WinAPI_CloseHandle($hFile)
EndFunc

Func _Dismount()
$TargetDrive = StringMid(GUICtrlRead($Combo1),1,2)
$dismount = _WinAPI_DismountVolume($hFile)
If $dismount = 0 Then
	_DisplayInfo("Error when dismounting " & $TargetDrive & @CRLF)
	Return
EndIf
_DisplayInfo("Successfully dismounted " & $TargetDrive & @CRLF)
EndFunc

Func _DismountForce()
$TargetDrive = StringMid(GUICtrlRead($Combo1),1,2)
$dismount = _WinAPI_DismountVolumeMod($TargetDrive)
If $dismount = 0 Then
	_DisplayInfo("Error when force dismounting " & $TargetDrive & @CRLF)
	Return
EndIf
_DisplayInfo("Successfully force dismounted " & $TargetDrive & @CRLF)
GUICtrlSetState($ButtonLock, $GUI_DISABLE)
GUICtrlSetState($Combo1, $GUI_DISABLE)
GUICtrlSetState($ButtonRefresh, $GUI_DISABLE)
GUICtrlSetState($ButtonUnlock, $GUI_DISABLE)
GUICtrlSetState($ButtonDismount, $GUI_DISABLE)
EndFunc

Func _ForceRemount()
$CloseHandle = _WinAPI_CloseHandle($hFile)
If $CloseHandle = 0 Then
	_DisplayInfo("Error when force remount/unlock drive (CloseHandle)." & @CRLF)
	Return
EndIf
_DisplayInfo("Successfully force remounted & unlocked drive." & @CRLF)
GUICtrlSetState($ButtonLock, $GUI_ENABLE)
GUICtrlSetState($Combo1, $GUI_ENABLE)
GUICtrlSetState($ButtonRefresh, $GUI_ENABLE)
GUICtrlSetState($ButtonUnlock, $GUI_ENABLE)
GUICtrlSetState($ButtonDismount, $GUI_ENABLE)
EndFunc

Func _DisplayInfo($DegugInfo)
GUICtrlSetData($myctredit, $DegugInfo, 1)
EndFunc

Func _WinAPI_LockVolume($iVolume)
	$hFile = _WinAPI_CreateFileEx('\\.\' & $iVolume, 3, BitOR($GENERIC_READ,$GENERIC_WRITE), 0x7)
	If Not $hFile Then
		Return SetError(1, 0, 0)
	EndIf
	Local $Ret = DllCall('kernel32.dll', 'int', 'DeviceIoControl', 'ptr', $hFile, 'dword', $FSCTL_LOCK_VOLUME, 'ptr', 0, 'dword', 0, 'ptr', 0, 'dword', 0, 'dword*', 0, 'ptr', 0)
	If (@error) Or (Not $Ret[0]) Then
		$Ret = 0
	EndIf
	If Not IsArray($Ret) Then
		Return SetError(2, 0, 0)
	EndIf
	Return $Ret[0]
EndFunc   ;==>_WinAPI_LockVolume

Func _WinAPI_UnLockVolume($hFile)
	If Not $hFile Then
		_DisplayInfo("Error in _WinAPI_CreateFileEx when unlocking." & @CRLF)
		Return SetError(1, 0, 0)
	EndIf
	Local $Ret = DllCall('kernel32.dll', 'int', 'DeviceIoControl', 'ptr', $hFile, 'dword', $FSCTL_UNLOCK_VOLUME, 'ptr', 0, 'dword', 0, 'ptr', 0, 'dword', 0, 'dword*', 0, 'ptr', 0)
	If (@error) Or (Not $Ret[0]) Then
		$Ret = 0
	EndIf
	If Not IsArray($Ret) Then
		Return SetError(2, 0, 0)
	EndIf
	Return $Ret[0]
EndFunc   ;==>_WinAPI_UnLockVolume

Func _WinAPI_DismountVolume($hFile)
	If Not $hFile Then
		_DisplayInfo("Error in _WinAPI_CreateFileEx when dismounting." & @CRLF)
		Return SetError(1, 0, 0)
	EndIf
	Local $Ret = DllCall('kernel32.dll', 'int', 'DeviceIoControl', 'ptr', $hFile, 'dword', $FSCTL_DISMOUNT_VOLUME, 'ptr', 0, 'dword', 0, 'ptr', 0, 'dword', 0, 'dword*', 0, 'ptr', 0)
	If (@error) Or (Not $Ret[0]) Then
		$Ret = 0
	EndIf
	If Not IsArray($Ret) Then
		Return SetError(2, 0, 0)
	EndIf
	Return $Ret[0]
EndFunc   ;==>_WinAPI_DismountVolume

Func _WinAPI_DismountVolumeMod($iVolume)
	$hFile = _WinAPI_CreateFileEx('\\.\' & $iVolume, 3, BitOR($GENERIC_READ,$GENERIC_WRITE), 0x7)
	If Not $hFile Then
		_DisplayInfo("Error in _WinAPI_CreateFileEx when dismounting." & @CRLF)
		Return SetError(1, 0, 0)
	EndIf
	Local $Ret = DllCall('kernel32.dll', 'int', 'DeviceIoControl', 'ptr', $hFile, 'dword', $FSCTL_DISMOUNT_VOLUME, 'ptr', 0, 'dword', 0, 'ptr', 0, 'dword', 0, 'dword*', 0, 'ptr', 0)
	If (@error) Or (Not $Ret[0]) Then
		$Ret = 0
	EndIf
	If Not IsArray($Ret) Then
		Return SetError(2, 0, 0)
	EndIf
	Return $Ret[0]
EndFunc   ;==>_WinAPI_DismountVolumeMod

Func _GetPhysicalDrives()
$menu = ''
$entry = ''
For $i = 0 To UBound($Drive) - 1
    $List[$i] = ''
Next
If IsArray($Drive) Then
    For $i = 1 To $Drive[0]
        $tSTORAGE_DEVICE_NUMBER = _WinAPI_GetDriveNumber($Drive[$i])
        If Not @error Then
            $List[DllStructGetData($tSTORAGE_DEVICE_NUMBER, 'DeviceNumber')] &= StringUpper($Drive[$i]) & ' '
        EndIf
    Next
EndIf
For $i = 0 To UBound($Drive) - 1
    If $List[$i] Then
		ConsoleWrite('\\.\PhysicalDrive' & $i & @CRLF)
		_DisplayInfo("Detected: " & '\\.\PhysicalDrive' & $i & @CRLF)
    EndIf
Next
EndFunc

Func _GetVolumes()
GUICtrlSetData($Combo1,"","")
$menu = ''
$entry = ''
$Text = ''
$var = DriveGetDrive( "all" )
If NOT @error Then
    For $i = 1 to $var[0]
		$DriveType = DriveGetType($var[$i])
		$DriveCapacity = DriveSpaceTotal($var[$i])
		$Bus = _WinAPI_GetDriveBusType($var[$i])
		Switch $Bus
			Case $DRIVE_BUS_TYPE_UNKNOWN
				$Text = 'UNKNOWN'
			Case $DRIVE_BUS_TYPE_SCSI
				$Text = 'SCSI'
			Case $DRIVE_BUS_TYPE_ATAPI
				$Text = 'ATAPI'
			Case $DRIVE_BUS_TYPE_ATA
				$Text = 'ATA'
			Case $DRIVE_BUS_TYPE_1394
				$Text = '1394'
			Case $DRIVE_BUS_TYPE_SSA
				$Text = 'SSA'
			Case $DRIVE_BUS_TYPE_FIBRE
				$Text = 'FIBRE'
			Case $DRIVE_BUS_TYPE_USB
				$Text = 'USB'
			Case $DRIVE_BUS_TYPE_RAID
				$Text = 'RAID'
			Case $DRIVE_BUS_TYPE_ISCSI
				$Text = 'ISCSI'
			Case $DRIVE_BUS_TYPE_SAS
				$Text = 'SAS'
			Case $DRIVE_BUS_TYPE_SATA
				$Text = 'SATA'
			Case $DRIVE_BUS_TYPE_SD
				$Text = 'SD'
			Case $DRIVE_BUS_TYPE_MMC
				$Text = 'MMC'
		EndSwitch
		$entry = StringUpper($var[$i]) & "  (" & $DriveType & ")  - " & $Text & "  - " & Round($DriveCapacity,0) & " MB" & "|"
		$menu &=  $entry
    Next
Else
	_DisplayInfo("Error - something went wrong in Func _GetVolumes." & @CRLF)
	Return
EndIf
GUICtrlSetData($Combo1,$menu,StringMid($entry,1,StringLen($entry)-1))
EndFunc

#cs
Func _WinAPI_DiskGetPartitionInfo($hFile)

;	Local $hFile = _WinAPI_CreateFileEx('\\.\' & $iPartition, 3, 0x80000000, 0x01)

	If Not $hFile Then
		Return SetError(1, 0, 0)
	EndIf

	Local $tDISK_PARTITION_INFO = DllStructCreate($tagPARTITION_INFO)
	Local $Ret = DllCall('kernel32.dll', 'int', 'DeviceIoControl', 'ptr', $hFile, 'dword', $IOCTL_DISK_GET_PARTITION_INFO, 'ptr', 0, 'dword', 0, 'ptr', DllStructGetPtr($tDISK_PARTITION_INFO), 'dword', DllStructGetSize($tDISK_PARTITION_INFO), 'dword*', 0, 'ptr', 0)

	If (@error) Or (Not $Ret[0]) Then
		$Ret = 0
	EndIf
;	_WinAPI_CloseHandle($hFile)
	If Not IsArray($Ret) Then
		Return SetError(2, 0, 0)
	EndIf
	Return $tDISK_PARTITION_INFO
EndFunc   ;==>_WinAPI_DiskGetPartitionInfo
#ce




